
#include <stdio.h>
#include <stdarg.h>
#include <SDL2/SDL_log.h>
#if defined(_WIN32)
#include <windows.h>
#endif

void __attribute__ ((format (printf, 1, 2))) _print_info(const char *format, ...)
{
	va_list args;
	va_start(args, format);

	SDL_LogMessageV(SDL_LOG_CATEGORY_APPLICATION, SDL_LOG_PRIORITY_INFO, format, args);

	va_end(args);
}

void __attribute__ ((format (printf, 3, 4))) _print_error(const char *_file, int _line, const char *format, ...)
{
	va_list args;
	va_start(args, format);

#if defined(_WIN32)
	char title[123], text[1234];
	snprintf(title, sizeof(title), "Error in %s line %d:\n", _file, _line);
	title[sizeof(title) - 1] = '\0';
	vsnprintf(text, sizeof(text), format, args);
	text[sizeof(text) - 1] = '\0';
	MessageBox(NULL, text, title, MB_OK);
#else
	SDL_LogMessage(SDL_LOG_CATEGORY_APPLICATION, SDL_LOG_PRIORITY_ERROR, "Error in %s line %d:\n", _file, _line);
	SDL_LogMessageV(SDL_LOG_CATEGORY_APPLICATION, SDL_LOG_PRIORITY_ERROR, format, args);
#endif

	va_end(args);
}

